/*
 * The ForwardListIterator class steps through a /list object.
 */

#if !defined(PIF_NOPREFIX_GENERAL) && !defined(PIF_NOPREFIX_ITERATOR)
pif_Iterator/ForwardListIterator
#else
Iterator/ForwardListIterator
#endif
	var
		list/source
		position = null

	proc
		_SetPosition(p)
			if(position == 0)
				return 0

			if((p < 1) || (p > source.len))
				position = 0
			else
				position = p

			return position

		_Get(p)
			if((p < 1) || (p > source.len))
				return null
			else
				return source[p]

	/*
	 * Protocol implementation.
	 */


	New(list/_source)
		if(istype(_source))
			source = _source
		else
#if !defined(PIF_NOPREFIX_GENERAL) && !defined(PIF_NOPREFIX_ITERATOR)
			throw EXCEPTION("Expecting /list object for /pif_Iterator/ForwardListIterator constructor.")
#else
			throw EXCEPTION("Expecting /list object for /Iterator/ForwardListIterator constructor.")
#endif

	Initialize(_position = 1)
		return !!_SetPosition(_position)

	Next(_position = null)
		return _SetPosition(
			(_position == null) ? (Position() + 1) : _position
			)

	Step(step = 1)
		return _SetPosition(Position() + step)

	Look()
		return _Get(Position())

	Peek(step = 1)
		return Done() ? null : _Get(Position() + step)

	Done()
		return (Position() == 0)

	Position()
		return position